package com.rjconsultores.ventaboletos.web.gui.controladores.expressos;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Window;

import com.rjconsultores.ventaboletos.entidad.TrayectosExpresos;
import com.rjconsultores.ventaboletos.service.LogAuditoriaService;
import com.rjconsultores.ventaboletos.service.TrayectosExpresosService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

@Controller("cargarPlacaBusExpresosController")
@Scope("prototype")
public class CargarPlacaBusExpresoController extends MyGenericForwardComposer{
	private static final long serialVersionUID = 1L;
	
	@Autowired
	TrayectosExpresosService trayectosExpresosService;
	
	@Autowired
    private LogAuditoriaService logAuditoriaService;
	
	TrayectosExpresos trayecto;
	TrayectosExpresos trayectoClone;
	
	private MyTextbox txtRuta;
	private MyTextbox txtNumPlaca;
	
	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		trayecto = (TrayectosExpresos) Executions.getCurrent().getArg().get("trayecto");
		trayecto.clonar();
		trayectoClone = trayecto.getCloneObject();
		
		txtRuta.setValue(trayecto.getDescTrayecto() == null ? "" : trayecto.getDescTrayecto());
	}
	
	public void onClick$btnGuardar(Event event) throws Exception {
		if(txtNumPlaca.getValue() == null || txtNumPlaca.getValue() == "") {
			Messagebox.show(
					Labels.getLabel("cargaContratoController.MSG.errorNumPlacaInvalidOrNull"),
					Labels.getLabel("winCargarPlacaBusExpresos.title"),
					Messagebox.OK, Messagebox.ERROR);
		}else {
			trayecto.setNumPlaca(txtNumPlaca.getValue());
			trayectosExpresosService.actualizacion(trayecto);
			
			logAuditoriaService.auditar(trayectoClone, trayecto, null);
			
			this.closeWindow();
		}
	}
}
